from flask_wtf import FlaskForm
from wtforms import StringField, PasswordField, BooleanField, SubmitField, TextAreaField, SelectField
from wtforms.validators import ValidationError, DataRequired, Email, EqualTo, Length

from app.models import User, Booking, Stack, Scenario

# TODO: get stacks and scenarios from DB dynamically
class BookingForm(FlaskForm):
  stacks = [('kubernetes', 'Kubernetes')]
  scenarios = [('k8-calico-nofeature', 'Kubernetes with Calico Network Plugin'),
               ('k8-canal-nofeature', 'Kubernetes with Canal Network Plugin'),
               ('k8-cilium-nofeature', 'Kubernetes with Cilium Network Plugin'),
               ('k8-flannel-nofeature', 'Kubernetes with Flannel Network Plugin'),
               ('k8-multus-nofeature', 'Kubernetes with Multus Network Plugin'),
               ('k8-weave-nofeature', 'Kubernetes with Weave Network Plugin')]
  booking_length = [('1', '1 day',), ('3', '3 days'), ('5', '5 days'), ('7', '7 days')]
  email = StringField('New booking for', validators=[Length(min=0, max=140)], render_kw={'readonly': True})
  stack = SelectField('Stack', choices=stacks, validators=[Length(min=0, max=140)])
  scenario = SelectField('Configuration', choices=scenarios, validators=[Length(min=0, max=140)])
  booking_length = SelectField('Days to keep the booking for', choices=booking_length, validators=[Length(min=0, max=10)])
  submit = SubmitField('Submit')

  def __init__(self, original_email, *args, **kwargs):
    super(BookingForm, self).__init__(*args, **kwargs)
    self.original_email = original_email
